<?php

$imagepath = "image/vector5_%04d.png";


if (($s = @$_POST["t0"]) !== null) {
	$frameratio = $_POST["frameratio"] + 0;
	$g0 = imagecreatetruecolor(800, 400);
	$c0 = imagecolorresolve($g0, 255, 255, 255);
	$frame = -1;
	$msec = 0;
	foreach (split("\r|\n|\r\n", $s) as $line) {
		$a = explode(" ", $line, 5);
		switch ($a[0]) {
			default:
				continue 2;
			case	"m":
				if ($frame < 0)
					$frame = 0;
				else {
					while ($msec < $a[1] + 0) {
						imagepng($g0, sprintf($imagepath, $frame));
						printf('<IMG src="'.$imagepath.'" width=400 height=200><A href="'.$imagepath.'">%04d</A><BR>', $frame, $frame, $frame);
						flush();
						$frame++;
						$msec += 1000 / $frameratio;
					}
				}
				imagefilledrectangle($g0, 0, 0, 800, 400, $c0);
				continue 2;
			case	"t":
				$r = $g = $b = 0;
				if (ereg('^#([0-9A-Fa-f])([0-9A-Fa-f])([0-9A-Fa-f])', $a[3], $array))
					list(, $r, $g, $b) = $array;
				$c = imagecolorresolve($g0, $r * 0x11, $g * 0x11, $b * 0x11);
				imagestring($g0, 4, $a[1] + 0, $a[2] + 0, $a[4], $c);
				continue 2;
			case	"p":
				$points = explode(" ", $a[4]);
				if (ereg('^#([0-9A-Fa-f])([0-9A-Fa-f])([0-9A-Fa-f])', $a[3], $array)) {
					list(, $r, $g, $b) = $array;
					$c = imagecolorresolve($g0, $r * 0x11, $g * 0x11, $b * 0x11);
					imagefilledpolygon($g0, $points, count($points) / 2, $c);
				}
				if (($w = $a[2] + 0) == 0)
					;
				else if (ereg('^#([0-9A-Fa-f])([0-9A-Fa-f])([0-9A-Fa-f])', $a[1], $array)) {
					list(, $r, $g, $b) = $array;
					$c = imagecolorresolve($g0, ("0x".$r) * 0x11, ("0x".$g) * 0x11, ("0x".$b) * 0x11);
					imagesetthickness($g0, $w);
					imagepolygon($g0, $points, count($points) / 2, $c);
				}
				continue 2;
		}
		break;
	}
	imagepng($g0, sprintf($imagepath, $frame));
	printf('<IMG src="'.$imagepath.'" width=400 height=200><A href="'.$imagepath.'">%04d</A><BR>', $frame, $frame, $frame);
	die();
}


print <<<EOO
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN""http://www.w3.org/TR/html4/loose.dtd">
<!-- copy from: http://musicgroupwork.at.webry.info/200701/article_2.html -->
<!-- copy from: http://jsm.suepon.com/script/jsm31.html -->
<html>
<head>
<script type="text/javascript"><!--

handlelist = null;
vectorlist = new Array();
starttime = new Date();
logtext = "";


function	vector(container, arrowsize, width, color) {
	this.sx = 0;
	this.sy = 0;
	this.ex = 0;
	this.ey = 0;
	this.points = "";
	this.polygon = document.createElementNS("http://www.w3.org/2000/svg", "polygon");
	this.polygon.setAttribute("stroke", color);
	this.polygon.setAttribute("fill", "none");
	this.polygon.setAttribute("stroke-width", width);
	container.appendChild(this.polygon);
	
	this.setup = function() {
		this.calc();
		
		var	vx = this.ex - this.sx;
		var	vy = this.ey - this.sy;
		this.points = this.sx + ", " + this.sy;
		this.points += ", " + this.ex + ", " + this.ey;
		if (vx || vy) {
			var	length = Math.sqrt(vx * vx + vy * vy);
			vx = vx * arrowsize / length;
			vy = vy * arrowsize / length;
			this.points += ", " + (this.ex - vx - vy / 2);
			this.points += ", " + (this.ey - vy + vx / 2);
			this.points += ", " + (this.ex - vx + vy / 2);
			this.points += ", " + (this.ey - vy - vx / 2);
			this.points += ", " + this.ex + ", " + this.ey;
		}
		this.polygon.setAttribute("points", this.points);
	};
	this.calc = function() {
	};
	this.dump = function() {
		var	s = "p " + color + " " + width + " " + "none";
		var	a = this.points.split(" ");
		for (var i=0; i<a.length; i++)
			s += " " + parseInt(a[i]);
		return s + "\\n";
	};
}


function	setupvector() {
	for (var i=0; i<vectorlist.length; i++)
		vectorlist[i].setup();
}


function	dumpvector() {
	var	now = new Date();
	
	logtext += "m " + ((now.getTime() - starttime.getTime()) & 0xffffff) + "\\n";
	for (var i=0; i<vectorlist.length; i++)
		logtext += vectorlist[i].dump();
	for (var i=0; i<handlelist.length; i++) {
		var	h = handlelist[i];
		logtext += "t " + parseInt(h.style.left) + " " + parseInt(h.style.top) + " #000 " + h.innerHTML + "\\n";
	}
}


function	setuphandle(obj) {
	obj.onmousedown = function(e) {
		var	offset_x = e.pageX - parseInt(obj.style.left);
		var	offset_y = e.pageY - parseInt(obj.style.top);
		
		document.onmousemove = function(e) {
			var	x = e.pageX - offset_x;
			var	y = e.pageY - offset_y;
			obj.style.left = x + 'px';
			obj.style.top = y + 'px';
			setupvector();
			dumpvector();
			return false;
		};
		document.onmouseup = function(e) {
			document.onmousemove(e);
			document.onmouseup = null;
			document.onmousemove = null;
//			dumpvector();
			return false;
		};
		document.onmousemove(e);
		return false;
	};
}


window.onload = function() {
	var	obj;
	var	containerObj = document.createElementNS("http://www.w3.org/2000/svg", "svg");
	document.getElementById("canvas").appendChild(containerObj);
	
	handlelist = document.getElementById("canvas").getElementsByTagName("div");
	for (var i=0; i<handlelist.length; i++)
		setuphandle(handlelist[i]);
	
	vectorlist.push(obj = new vector(containerObj, 10, 4, "#00f"));
	obj.calc = function() {
		this.sx = 200;
		this.sy = 200;
		this.ex = parseInt(handlelist[2].style.left);
		this.ey = 200;
	};
	vectorlist.push(obj = new vector(containerObj, 10, 4, "#f00"));
	obj.calc = function() {
		this.sx = parseInt(handlelist[2].style.left);
		this.sy = 200;
		this.ex = parseInt(handlelist[2].style.left);
		this.ey = parseInt(handlelist[2].style.top);
		handlelist[2].innerHTML = "+ (" + ((this.ex - 200) / 100.0) + ", " + ((200 - this.ey) / 100.0) + ")";
	};
	vectorlist.push(obj = new vector(containerObj, 15, 1, "#0ff"));
	obj.calc = function() {
		this.sx = 600;
		this.sy = 200;
		this.ex = parseInt(handlelist[0].style.left);
		this.ey = parseInt(handlelist[0].style.top);
		handlelist[0].innerHTML = "+ (" + ((this.ex - 600) / 100.0) + ", " + ((200 - this.ey) / 100.0) + ")";
	};
	vectorlist.push(obj = new vector(containerObj, 15, 1, "#fa0"));
	obj.calc = function() {
		this.sx = 600;
		this.sy = 200;
		this.ex = parseInt(handlelist[1].style.left);
		this.ey = parseInt(handlelist[1].style.top);
		handlelist[1].innerHTML = "+ (" + ((this.ex - 600) / 100.0) + ", " + ((200 - this.ey) / 100.0) + ")";
	};
	vectorlist.push(obj = new vector(containerObj, 10, 4, "#00f"));
	obj.calc = function() {
		var	vx0 = parseInt(handlelist[0].style.left) - 600;
		var	vy0 = parseInt(handlelist[0].style.top) - 200;
		
		this.sx = this.ex = 600;
		this.sy = this.ey = 200;
		this.ex += (parseInt(handlelist[2].style.left) - 200) * vx0 / 100;
		this.ey += (parseInt(handlelist[2].style.left) - 200) * vy0 / 100;
	};
	vectorlist.push(obj = new vector(containerObj, 10, 4, "#f00"));
	obj.calc = function() {
		var	vx0 = parseInt(handlelist[0].style.left) - 600;
		var	vy0 = parseInt(handlelist[0].style.top) - 200;
		var	vx1 = parseInt(handlelist[1].style.left) - 600;
		var	vy1 = parseInt(handlelist[1].style.top) - 200;
		
		this.sx = 600;
		this.sy = 200;
		this.sx += (parseInt(handlelist[2].style.left) - 200) * vx0 / 100;
		this.sy += (parseInt(handlelist[2].style.left) - 200) * vy0 / 100;
		this.ex = this.sx;
		this.ey = this.sy;
		this.ex += (200 - parseInt(handlelist[2].style.top)) * vx1 / 100;
		this.ey += (200 - parseInt(handlelist[2].style.top)) * vy1 / 100;
	};
	setupvector();
}


// --></script>
<title>vector operation</title>
</head>
<body>
<div id="canvas" style="width:800px; height:400px;">
	<div style="position:absolute; left:700px; top:200px;">+</div>
	<div style="position:absolute; left:600px; top:100px;">+</div>
	<div style="position:absolute; left:250px; top:150px;">+</div>
</div>
<HR>
<FORM name=form0 method=POST onsubmit="document.form0.t0.value = logtext;">
<TEXTAREA name=t0 cols=60 rows=10>
</TEXTAREA>
frame ratio: <INPUT type=text name=frameratio value="20">
<INPUT type=submit>
</FORM>
<HR>
</body>
</html>
EOO;

?>
